from ..modules.FurnitureImportModule import ImportFurniture
from ..modules.CreateFloorModule import CreateFloor
from ..modules.InfoModule import InfoModule
from ..modules.ToolsModule import ToolsModule
from ..modules.ModifyRoomModule import  ModifyRoom
from ..Static import Static
import adsk.core, adsk.fusion, adsk.cam

class DecorItButtonExecuteEventHandler(adsk.core.CommandEventHandler):
    def __init__(self):
        super().__init__()
    def notify(self, args):
        eventArgs = adsk.core.CommandEventArgs.cast(args)
        inputs = eventArgs.command.commandInputs

        mainTab = inputs.itemById("tab_main")
        roomTab = inputs.itemById("tab_room")
        furnitureTab = inputs.itemById("tab_furniture")
        toolsTab = inputs.itemById("tab_tools")

        if mainTab.isActive:
            floor = CreateFloor()
            floor.createFloor(inputs)

        elif toolsTab.isActive:
            ToolsModule().adjust(toolsTab.children)

        elif roomTab.isActive:
            selected_wall = None
            if inputs.itemById("wall_selection").selectionCount > 0:
                selected_wall = inputs.itemById("wall_selection").selection(0).entity
            room = ModifyRoom()

            windowOrDoor = inputs.itemById("type_select")
            position = inputs.itemById("position_select")

            type = windowOrDoor.selectedItem.name
            position = position.selectedItem.name

            room.createWindowOrDoor(inputs, selected_wall, type, position)


        elif furnitureTab.isActive:
            table = inputs.itemById('furniture_table')
            if table.selectedRow == -1:
                return
            s_input = table.getInputAtPosition(table.selectedRow, 1)

            selected_face = None
            if inputs.itemById("furniture_face_selection").selectionCount > 0:
                selected_face = inputs.itemById("furniture_face_selection").selection(0).entity

            # furniture_select = inputs.itemById("furniture_select")
            furniture_name = s_input.name
            furniture_import = ImportFurniture()
            furniture_import.load_furniture(furniture_name, selected_face)