import os
import re
import adsk.core, adsk.fusion, adsk.cam, traceback
from ..Static import Static

class ImportFurniture:
    def get_furniture_count(self, name):
        product = Static.app.activeProduct
        rootComp = product.rootComponent
        instance = 1
        for i in rootComp.occurrences:
            if i.name == name + f":{instance}":
                instance += 1
        return instance

    def get_file_details(self, name):
        FILE_PATH = None
        FILE_NAME = "Shelf"
        APPEARANCE = "Pine"
        if name == "Shelf":
            FILE_PATH = Static.base + "\\models\\Shelf.smt"
            FILE_NAME = "Shelf 1 v2"
            APPEARANCE = "Pine"
        if name == "Chair":
            FILE_PATH = Static.base + "\\models\\Chair.smt"
            FILE_NAME = "Chair 1 v2"
            APPEARANCE = "Oak"
        if name == "Table":
            FILE_PATH = Static.base + "\\models\\Table.smt"
            FILE_NAME = "Table 1 v2"
            APPEARANCE = "Paint - Enamel Glossy (White)"
        return FILE_PATH, FILE_NAME, APPEARANCE

    def align_furniture(self, occ, face):
        measure_result = Static.app.measureManager.measureMinimumDistance(occ, face)
        measure_pos1 = measure_result.positionOne
        measure_pos2 = measure_result.positionTwo

        move_x = 0.0 if abs(measure_pos2.x - measure_pos1.x) <=1 else measure_pos2.x - measure_pos1.x
        move_y = 0.0 if abs(measure_pos2.y - measure_pos1.y) <=1 else measure_pos2.y - measure_pos1.y

        existing_transform = occ.transform
        existing_translation = existing_transform.translation
        existing_translation.x += move_x
        existing_translation.y += move_y

        modified_transform = existing_transform
        modified_transform.translation = adsk.core.Vector3D.create(existing_translation.x, existing_translation.y, existing_translation.z)

        occ.transform = modified_transform

        Static.app.activeViewport.refresh()


    def load_furniture(self, name, face):
        result = None
        try:
            FILE_PATH, FILE_NAME, APPEARANCE = self.get_file_details(name)

            product = Static.app.activeProduct
            rootComp = product.rootComponent
            importmgr = Static.app.importManager

            archiveOptions = importmgr.createSMTImportOptions(FILE_PATH)
            archiveOptions.isViewFit = False
            importmgr.importToTarget2(archiveOptions, rootComp)
            # result = importmgr.importToTarget(archiveOptions, rootComp)
            # occ = adsk.fusion.Occurrence.cast(result.item(0))
            # # occ.name = FILE_NAME + f":{self.get_furniture_count(name)}"
            # body = occ.bRepBodies.item(0)
            # fusionAppearence = Static.app.materialLibraries.itemByName('Fusion 360 Appearance Library')
            # appearance = fusionAppearence.appearances.itemByName(APPEARANCE)
            # body.appearance = appearance

            # if face:
                # self.align_furniture(occ, face)
    
            # removeFeatures = rootComp.features.removeFeatures
            # instance = self.get_furniture_count(FILE_NAME)
            # for i in rootComp.occurrences:
            #     if i.name == FILE_NAME + f":{instance}":
            #         body = i.bRepBodies.item(0)
            #         fusionAppearence = Static.app.materialLibraries.itemByName('Fusion 360 Appearance Library')
            #         appearance = fusionAppearence.appearances.itemByName(APPEARANCE)
            #         body.appearance = appearance
                    
            #         # transform = adsk.core.Matrix3D.create()
            #         # vector = adsk.core.Vector3D.create(0.0, 0.0, 50.0)
            #         # transform.translation = vector
            #         #body.transform = transform

            #         # entities1 = adsk.core.ObjectCollection.create()
            #         # entities1.add(body)

            #         # moveFeats = rootComp.features.moveFeatures
            #         # moveFeatureInput = moveFeats.createInput(entities1, transform)
            #         # moveFeats.add(moveFeatureInput)
            #         # #copyPasteBody = rootComp.features.copyPasteBodies.add(body)
            #         # #i.deleteMe()
            #         body.moveToComponent(rootComp)
            #         removeFeatures.add(i)
            # print("----")
        except:
            print(traceback.format_exc())
            if Static.ui:
                Static.ui.messageBox('Failed:\n{}'.format(traceback.format_exc()))

