from ..Static import Static
import adsk.core, adsk.fusion, adsk.cam, traceback

class InfoModule:
    def clear(self, inputs):
        ids = []
        for i in range(inputs.count):
            ids.append(inputs.item(i).id)
        for id in ids:
            inputs.itemById(id).deleteMe()

    def calculate(self, inputs):
        index = 1
        try:
            self.clear(inputs)
            product = Static.app.activeProduct
            rootComp = product.rootComponent
            total_floor = 0
            total_wall = 0
            for occ in rootComp.occurrences:
                if "Floor" in occ.name:
                    bodies = occ.component.bRepBodies
                    floor = bodies.itemByName('Floor 0')
                    # inputs.addTextBoxCommandInput('room' + str(index), '', '<b>Room ' + str(index) + '</b>', 1, True).isReadOnly = True
                    if floor:
                        area = abs(floor.boundingBox.minPoint.x - floor.boundingBox.maxPoint.x) * abs(floor.boundingBox.maxPoint.y - floor.boundingBox.minPoint.y)
                        total_floor += round(area / 10000.0, 2)
                        # inputs.addTextBoxCommandInput('info'+ str(index) + '1', 'Total Floor Area: ', str(area) + '<b> sqm</b>', 1, True).isReadOnly = True 
                    
                    wall = bodies.itemByName('Wall 1')
                    if wall:
                        area = 0
                        for face in wall.faces:
                            area = max(area, face.area)
                        total_wall += round(area / 10000.0, 2)
                        # inputs.addTextBoxCommandInput('info'+ str(index) + '1', 'Wall 1 Area: ', str(area) + '<b> sqm</b>', 1, True).isReadOnly = True
                    wall = bodies.itemByName('Wall 2')
                    if wall:
                        area = 0
                        for face in wall.faces:
                            area = max(area, face.area)
                        total_wall += round(area / 10000.0, 2)
                    wall = bodies.itemByName('Wall 3')
                    if wall:
                        area = 0
                        for face in wall.faces:
                            area = max(area, face.area)
                        total_wall += round(area / 10000.0, 2)
                    wall = bodies.itemByName('Wall 4')
                    if wall:
                        area = 0
                        for face in wall.faces:
                            area = max(area, face.area)
                        total_wall += round(area / 10000.0, 2)
            
            paint_needed = total_wall * 0.1 + (total_wall * 0.1 * 0.1)
            inputs.addTextBoxCommandInput('floor_area_info', 'Total Floor Area', str(total_floor) + '<b> sqm</b>', 1, True).isReadOnly = True
            inputs.addTextBoxCommandInput('wall_area_info', 'Total Wall Area', str(total_wall) + '<b> sqm</b>', 1, True).isReadOnly = True
            inputs.addTextBoxCommandInput('paint_area_info', 'Estimated Paint Needed', str(paint_needed) + '<b> Litres* </b>', 1, True).isReadOnly = True
        except:
            if Static.ui:
                Static.ui.messageBox('Failed:\n{}'.format(traceback.format_exc()))

