from ..Static import Static
import adsk.core, adsk.fusion, adsk.cam, traceback

class ModifyRoom:
    def __init__(self) -> None:
        pass

    def createWindowOrDoor(self, inputs, walls, type, position):
        height = inputs.itemById("windowOrDoor_height_input").value
        width = inputs.itemById("windowOrDoor_width_input").value

        try:
            wall_body = walls.body
            if abs(wall_body.boundingBox.minPoint.x) > abs(width) and abs(wall_body.boundingBox.maxPoint.y) > abs(height):

                comp = wall_body.parentComponent
                extrudes = comp.features.extrudeFeatures
                sketches = comp.sketches

                planes = comp.constructionPlanes
                planeInput = planes.createInput()
                offsetValue = adsk.core.ValueInput.createByReal(3.0)
                planeInput.setByOffset(walls, offsetValue)
                planeOne = planes.add(planeInput)
                sketch = sketches.add(planeOne)
                lines = sketch.sketchCurves.sketchLines
                offset = 75
                if type == "Window":
                    if wall_body.name == "Wall 2" or wall_body.name == "Wall 3":
                        if position == "Centre":
                            point1 = adsk.core.Point3D.create(width/2, height/2, 0)
                            point2 = adsk.core.Point3D.create(-width/2, -height/2, 0)
                        elif position == "Left":
                            point1 = adsk.core.Point3D.create(width/2 -offset, height/2, 0)
                            point2 = adsk.core.Point3D.create(-width/2 -offset, -height/2, 0)
                        elif position == "Right":
                            point1 = adsk.core.Point3D.create(width/2 + offset, height/2, 0)
                            point2 = adsk.core.Point3D.create(-width/2 + offset, -height/2, 0)

                    elif wall_body.name == "Wall 1" or wall_body.name == "Wall 4":
                        if position == "Centre":
                            point1 = adsk.core.Point3D.create(width/2, height/2, 0)
                            point2 = adsk.core.Point3D.create(-width/2, -height/2, 0)
                        elif position == "Left":
                            point1 = adsk.core.Point3D.create(width/2, height/2 - offset, 0)
                            point2 = adsk.core.Point3D.create(-width/2, -height/2 - offset, 0)
                        elif position == "Right":
                            point1 = adsk.core.Point3D.create(width/2, height/2 + offset, 0)
                            point2 = adsk.core.Point3D.create(-width/2, -height/2 + offset, 0)

                if type == "Door":
                    wall_height = abs(wall_body.boundingBox.minPoint.z - wall_body.boundingBox.maxPoint.z)
                    if wall_body.name == "Wall 1" or wall_body.name == "Wall 4":
                        if position == "Centre":
                            point1 = adsk.core.Point3D.create(wall_height/2, - width/2, 0)
                            point2 = adsk.core.Point3D.create(wall_height/2  - height, width/2, 0)
                        elif position == "Left":
                            point1 = adsk.core.Point3D.create(wall_height/2, - width/2 - offset, 0)
                            point2 = adsk.core.Point3D.create(wall_height/2  - height, width/2 - offset, 0)
                        elif position == "Right":
                            point1 = adsk.core.Point3D.create(wall_height/2, - width/2 + offset, 0)
                            point2 = adsk.core.Point3D.create(wall_height/2  - height, width/2 + offset, 0)

                    elif wall_body.name == "Wall 2" or wall_body.name == "Wall 3":
                        if position == "Centre":
                            point1 = adsk.core.Point3D.create( - width/2, - wall_height/2, 0)
                            point2 = adsk.core.Point3D.create( width/2, - wall_height/2  + height, 0)
                        elif position == "Left":
                            point1 = adsk.core.Point3D.create( - width/2 - offset, - wall_height/2, 0)
                            point2 = adsk.core.Point3D.create( width/2 - offset, - wall_height/2  + height, 0)
                        elif position == "Right":
                            point1 = adsk.core.Point3D.create( - width/2 + offset, - wall_height/2, 0)
                            point2 = adsk.core.Point3D.create( width/2 + offset, - wall_height/2  + height, 0)
                

                lines.addTwoPointRectangle(point1, point2 )
                prof = sketch.profiles.item(0)
            
                distance = adsk.core.ValueInput.createByReal(-150)
                extrude1 = extrudes.addSimple(prof, distance, adsk.fusion.FeatureOperations.CutFeatureOperation)
            
            else:
                Static.ui.messageBox('Too large!')

        except:
            if Static.ui:
                Static.ui.messageBox('Failed:\n{}'.format(traceback.format_exc()))
